#include "common.h"
#include "main.h"
#include "gnu_getpass.h"


int main() {
	pid_t pid;	
int sock,recv_len,i,state;
	int cm_recvsock,cm_sendsock,cd_sock;
	char *recv_tok[32]={NULL,};
	char *ip_port[2];
	char buf[MAX_BUF],user_id[64];
	char ch_sendbuf[MAX_BUF];
	char ch_recvbuf[MAX_BUF];	
	memset(ch_sendbuf,0x0,sizeof(ch_sendbuf));
	memset(ch_recvbuf,0x0,sizeof(ch_recvbuf));
	struct sigaction act;
	act.sa_handler=z_handler;
	sigemptyset(&act.sa_mask);
	act.sa_flags=0;
	
	state=sigaction(SIGCHLD,&act,0);
	if(state!=0) {
		error_handling("sigaction() error");
	}
	unsigned char md5_buf[34];
	unsigned char tmp_mdbuf[34];
	unsigned char md_buf[34];
	msn_session session;
	session.trid=1;
	

		
	sock=msn_init_session(&session);
	printf("return main()\n");
	fcntl(sock, F_SETFL, 0);
	memset(buf,0x0,MAX_BUF);
	while(recv_len=recv(sock,buf,MAX_BUF,0)) {
	printf("%s",buf);	
	if(strncmp(buf, "RNG", 3)==0) {
		memset(recv_tok,0x0,sizeof(recv_tok));
		memset(user_id,0x0,sizeof(user_id));
		pid=fork();
		msn_strtok(buf,recv_tok);
		strncpy(user_id,recv_tok[5],sizeof(user_id));
		//pid=fork();
		if(pid==0) {
			/* child process */
			printf("%s\n",recv_tok[2]);
			ip_port_tok(recv_tok[2],ip_port);
			cm_recvsock=tcp_connect(ip_port[0],atoi(ip_port[1]));
			cm_sendsock=dup(cm_recvsock);
			//shutdown(cm_recvsock,SHUT_WR);
			//shutdown(cm_sendsock,SHUT_RD);
			if(cm_sendsock==-1) error_handling("cm_sock error!!");
	snprintf(ch_sendbuf,MAX_BUF-1,"ANS %d %s %s %d\r\n",session.trid++,MSN_ID,recv_tok[4],atoi(recv_tok[1]));
		printf("check\n");	
		if(send(cm_sendsock,ch_sendbuf,strlen(ch_sendbuf),0)==-1) {
				error_handling("child send() error!!");
			}
			printf("%s",ch_sendbuf);
			memset(ch_sendbuf,0x0,sizeof(ch_sendbuf));
			recv(cm_recvsock,ch_recvbuf,sizeof(ch_recvbuf),0);
			printf("%s",ch_recvbuf);
			memset(buf,0x0,sizeof(buf));
			recv(cm_recvsock,ch_recvbuf,sizeof(ch_recvbuf),0);
			printf("%s",ch_recvbuf);
			memset(buf,0x0,sizeof(ch_recvbuf));	
			
			conv_server(&session,&cm_sendsock,&cm_recvsock,user_id);
			
			close(cm_sendsock);	
			close(cm_recvsock);

			return 0;
		}
		else {

			memset(buf,0x0,sizeof(buf));
		
		}		

	}
	else if(strncmp(buf,"CHL",3)==0) {
		memset(recv_tok,0x0,sizeof(recv_tok));
		memset(tmp_mdbuf,0x0,sizeof(tmp_mdbuf));
		memset(md_buf,0x0,sizeof(md_buf));
		buf[strlen(buf)-2]='\0';
		msn_strtok(buf,recv_tok);
		snprintf(tmp_mdbuf,MAX_BUF-1,"%sQ1P7W2E4J9R8U3S5",recv_tok[2]);
		
		tmp_mdbuf[strlen(tmp_mdbuf)]='\0';
				
		MD5(tmp_mdbuf,strlen(tmp_mdbuf),md_buf);
		for(i=0; i<16; i++) {
			//printf("%02x",md_buf[i]);
        		snprintf(&md5_buf[i*2],strlen(md_buf),"%02x",md_buf[i]);
		}
		snprintf(buf,MAX_BUF-1,"QRY %d msmsgs@msnmsgr.com 32\r\n%s",session.trid++,md5_buf);		
		printf("%s\n",buf);
		send(sock,buf,strlen(buf),0);	
	}
	memset(buf,0x0,MAX_BUF);
	
}		


	
		

	
	
}

void conv_server(msn_session *session,int *cm_sendsock,int *cm_recvsock,char *user_id) {
	char send_buf[MAX_BUF];
	char recv_buf[MAX_BUF];
	char u_send_buf[MAX_BUF];
	char u_recv_buf[MAX_BUF];
	char *u_send_ptr;
	char *recv_ptr;
	
	printf("\nstart func\n");
	
	char *msg_tok[32]={NULL,};
	char *msg_file_tok[5] = {NULL,};
	char format[64];
	char message[256];
	char tmp_buf[64];
	memset(format,0x0,sizeof(format));
	memset(message,0x0,sizeof(message));
	memset(send_buf,0x0,sizeof(send_buf));
        memset(u_recv_buf,0x0,sizeof(u_recv_buf));
	strncpy(message,"hahaha",sizeof(message));
	
	printf("while before\n");
	while(1) {
		printf("\nstart while\n");
		memset(msg_tok,0x0,sizeof(msg_tok));
		memset(send_buf,0x0,MAX_BUF);
		memset(u_recv_buf,0x0,sizeof(u_recv_buf));	
		memset(recv_buf,0x0,MAX_BUF);
		memset(u_send_buf,0x0,MAX_BUF);
		u_send_ptr=NULL;
		recv_ptr=NULL;
		
		snprintf(format, sizeof(format)-1, 
           "X-MMS-IM-Format: FN=Arial; EF=; CO=0; CS=81; PF=0");
			
		if(!(recv(*cm_recvsock,u_recv_buf,sizeof(u_recv_buf),0))) {
			error_handling("recv error!!");
		}

		
		printf("\nbefore : ");	
		printf("%s",u_recv_buf);
		recv_ptr=utf8_to_euckr(u_recv_buf);
		
		//&recv_buf[0]=*recv_ptr;
	printf("\nAfter : ");
		printf("%s",recv_ptr);
		if(strncmp(recv_buf,"BYE",3)==0) {
			snprintf(tmp_buf,64,"BYE %s\r\n",user_id);
			
			printf("BYE???\n");
			if(strncmp(recv_buf,tmp_buf,4+(strlen(user_id)))) {
				
				return ;
			
			}

			
		}
		
		//printf("%s\n",recv_buf);
		if(strncmp(recv_buf,"MSG",3)==0) {

			msn_strtok_null(recv_buf,msg_tok);

			printf("\ntok[3] is : %s\n",msg_tok[3]);
			if(strncmp(msg_tok[3],"X-MMS-IM-Format",15)==0) {
				memset(send_buf,0x0,MAX_BUF);

				snprintf(send_buf,MAX_BUF-1,"MSG %d N %d\r\nMIME-Version: 1.0\r\nContent-Type: text/plain; charset=UTF-8\r\nX-MMS-IM-Format: FN=Arial; EF=; CO=0; CS=81; PF=0\r\n\r\n%s",session->trid++,(strlen(format)+strlen(message)+64),message);

				//u_send_buf=euckr_to_utf8(send_buf);
				printf("\nu_send_buf len : %d\n",strlen(u_send_buf));
                		printf("send buf : \n%s",u_send_buf);
				/*
				if(send(*cm_sendsock,u_send_buf,strlen(u_send_buf),0)==-1)
                		{
                    			error_handling("cm_sock error!!");
                		}
				*/
				//printf("%s\n",u_send_buf);


			}
			else {
			memset(msg_file_tok,0x0,sizeof(msg_file_tok));
			msn_strtok(msg_tok[7],msg_file_tok);
			printf("msg_file_tok[0] : %s\n",msg_file_tok[0]);
			if(strncmp(msg_file_tok[0],"Application-File:",17)==0) {
					
				//printf("msg_tok[7] : %s\n",msg_tok[7]);
				printf("FILE TRANSFER");
				


			}
			else {
				//printf("not thing\n");
			}
	
			}
		printf("\nend while\n");

		}
		memset(send_buf,0x0,MAX_BUF);
		//memset(recv_buf,0x0,MAX_BUF);
	}
	free(recv_buf);
	free(u_send_buf);
	printf("while error\n");
	
}

void z_handler(int sig) {
	pid_t pid;
	int rtn;
	while((pid=waitpid(-1,&rtn,WNOHANG))>0) {

		printf("child process %d exit..\n",pid);
	}
}
